attribute table: virtual field values are not updated when underlying field values changes
Status: Feedback

Priority: Normal

Assignee:

Category: Attribute table

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 23709
Description

On master, the displayed values of virtual field(s) within an attribute table are not updated when the underlying field values are changed.
The user has to close the attribute table and re-open the window to see the changes.
Steps to reproduce

1.
. Open the layer properties window, and go to the Fields section

. Create a new virtual field with a simple expression that relies on a field present in the dataset (for e.g., "my_numerical_field * 2")
. Apply the change and close the properties window
Create a new project and add a vector dataset

. Open the attribute table window, and take a look at the virtual field values to verify the expression work
. Switch edit mode on via the attribute table window's toolbar button

. Click on a cell to change the value of the field you're using in your virutal field's expression

. Notice how the virtual field isn't updating

9.

Switch edit mode off and save the changes to the dataset

10. Notice how the virtual field isn't updating
11. Click on the refresh toolbar button
12. Notice how the virtual field isn't updating

While this is not a crucial issue per say (the user can close and re-open the window without losing data, etc.), it'd be important to have
virtual fields updating values as underlying data is changed as those occur.

History

#1 - 2017-01-05 07:01 AM - Giovanni Manghi
- Priority changed from High to Normal

#2 - 2017-05-01 01:02 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No

#3 - 2019-03-09 04:28 PM - Giovanni Manghi
- Status changed from Open to Feedback

Please check if this issue is still valid on QGIS 3.4.5 or 3.6.
